package com.gic.haoban.manage.web.interceptor;

import com.gic.haoban.auth.api.dto.UserRightDetailDTO;
import com.gic.haoban.common.utils.AuthRequestUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 测试登录拦截器
 *
 * @author zhurz
 */
public class TestLoginInterceptor extends HandlerInterceptorAdapter {

    private static Logger logger = LoggerFactory.getLogger(TestLoginInterceptor.class);

    @Override
    public boolean preHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o) throws Exception {
        // 测试用
        HttpServletRequest request = AuthRequestUtil.getRequest();
        String testFlag = request.getHeader("testFlag");
        if (!"Y".equals(testFlag)) return true;
        String testEnterpriseId = request.getHeader("testEnterpriseId");
        String testUserId = request.getHeader("testUserId");
        UserRightDetailDTO sessionUser = new UserRightDetailDTO();
        sessionUser.setUserId(testUserId);
        sessionUser.setEnterpriseId(testEnterpriseId);
        AuthRequestUtil.setSessionUser(sessionUser);
        return true;
    }

}
