package com.gic.haoban.manage.web.interceptor;

import com.alibaba.fastjson.JSONObject;
import com.gic.haoban.auth.api.anno.MenuCheck;
import com.gic.haoban.auth.api.dto.UserRightDetailDTO;
import com.gic.haoban.auth.api.enums.RoleCodeEnum;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.web.auth.AuthRequestUtil;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Map;

/**
 * Created 2018/7/20.
 *
 * @author hua
 */
public class WebInterceptor extends HandlerInterceptorAdapter {

    private static Logger logger= LoggerFactory.getLogger(WebInterceptor.class);

//    @Autowired
//    private ClerkRightManageService clerkRightManageService;


    private void errorResult(HttpServletResponse httpServletResponse, HaoBanErrCode errCode) {
        HaobanResponse response = new HaobanResponse();
        response.setErrorCode(errCode.getCode());
        response.setMessage(errCode.getMsg());
        PrintWriter writer = null;
        try {
            httpServletResponse.setHeader("Content-type", "application/json;charset=UTF-8");
            writer = httpServletResponse.getWriter();
            writer.append(JSONObject.toJSONString(response));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public boolean preHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o) throws Exception {
        String requestURI = httpServletRequest.getRequestURI();
        logger.info("post-url:{}", requestURI);
        Map<String, String[]> parameterMap = httpServletRequest.getParameterMap();
        logger.info("post-params:{}", JSONObject.toJSONString(parameterMap));
        
        HandlerMethod method = null;
        if (o instanceof HandlerMethod) {
            method = (HandlerMethod) (o);
        }
        if (method == null) {
            return true;
        }
        MenuCheck methodAnnotation = method.getMethodAnnotation(MenuCheck.class);
        
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, ModelAndView modelAndView) throws Exception {
        logger.info("end");
    }

    @Override
    public void afterCompletion(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Object o, Exception e) throws Exception {
        logger.info("end");
    }
}
