package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.service.dao.mapper.WxApplicationMapper;
import com.gic.haoban.manage.service.entity.TabHaobanWxApplication;
import com.gic.haoban.manage.service.service.WxApplicationService;

@Service
public class WxApplicationServiceImpl implements WxApplicationService {
	
	@Autowired
	private WxApplicationMapper mapper;

	@Override
	public TabHaobanWxApplication selectBySiteIdAndWxEnterpriseId(String siteId, String wxEnterpriseId) {
		
		return mapper.selectBySiteIdAndWxEnterpriseId(siteId,wxEnterpriseId);
	}

	@Override
	public void insert(TabHaobanWxApplication tab) {
		Date now = new Date();
		tab.setCreateTime(now);
		tab.setUpdateTime(now);
		tab.setStatusFlag(1);
		tab.setWxApplicationId(StringUtil.randomUUID());
		mapper.insertSelective(tab);
		
	}

	@Override
	public void update(TabHaobanWxApplication tab) {
		tab.setUpdateTime(new Date());
		mapper.updateByPrimaryKeySelective(tab);
		
	}

	@Override
	public TabHaobanWxApplication selectByWxEnterpriseIdAndApplicationType(String wxEnterpriseId, int applicationType) {
		List<TabHaobanWxApplication> list = mapper.selectByWxEnterpriseIdAndApplicationType(wxEnterpriseId, applicationType);
		if(CollectionUtils.isNotEmpty(list)){
			return list.get(0);
		}
		return null;
	}

	@Override
	public int cancalWxApplication(String wxEnterpriseId, String suiteId) {
		return this.mapper.cancelWxApplication(wxEnterpriseId, suiteId);
	}


}
