package com.gic.haoban.manage.service.service.out.impl;

import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.AuditSettingDTO;
import com.gic.haoban.manage.api.service.AuditSettingApiService;
import com.gic.haoban.manage.service.dao.mapper.AuditSettingMapper;
import com.gic.haoban.manage.service.entity.TabHaobanAuditSetting;

/**
 * Created by tgs on 2020/2/9.
 */
@Service
public class AuditSettingApiServiceImpl implements AuditSettingApiService{
	@Autowired
	private AuditSettingMapper auditSettingMapper;

	@Override
	public void saveSetting(String wxEnterpriseId, int auditFlag) {
		TabHaobanAuditSetting tab = auditSettingMapper.findSetting(wxEnterpriseId);
		if(tab == null){
			tab = new TabHaobanAuditSetting();
			tab.setAuditFlag(auditFlag);
			tab.setCreateTime(new Date());
			tab.setUpdateTime(new Date());
			tab.setSettingId(UuidUtil.randomUUID());
			tab.setStatusFlag(1);
			tab.setWxEnterpriseId(wxEnterpriseId);
			auditSettingMapper.insert(tab);
		}else{
			tab.setAuditFlag(auditFlag);
			tab.setUpdateTime(new Date());
			auditSettingMapper.updateByPrimaryKeySelective(tab);
		}
	}

	@Override
	public AuditSettingDTO findSettingByWxEnterpriseId(
			String wxEnterpriseId) {
		TabHaobanAuditSetting tab = auditSettingMapper.findSetting(wxEnterpriseId);
		if(tab == null){
			return null;
		}
		AuditSettingDTO dto = EntityUtil.changeEntity(AuditSettingDTO.class, tab);
		return dto;
	}
	
}
