package com.gic.haoban.manage.service.service.out.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import com.alibaba.fastjson.JSONObject;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.api.service.BindApiService;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.service.service.ApplicationService;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class BindApiServiceImpl implements BindApiService {
    private static Logger logger= LoggerFactory.getLogger(BindApiServiceImpl.class);

	@Autowired
	private ClerkService clerkService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;
	@Autowired
	private StoreService storeService;
	@Autowired
	private DepartmentApiService departmentApiService;

	@Transactional
	@Override
	public void clerkManagerTranfer(String departmentId, String fromClerkCode,
			String toStaffDepartmentRelatedId) {
		logger.info("===========================》222222222222222");
		DepartmentDTO departmentDTO = departmentApiService.selectById(departmentId);
		String storeId = departmentDTO.getRelatedId();
		StaffDepartmentRelatedDTO oldStaffDepartmentRelatedDTO = staffDepartmentRelatedApiService.getByStaffDepartmentRelatedId(toStaffDepartmentRelatedId);
		logger.info("===========================》333333333333333");
		//老店长
		StaffDepartmentRelatedDTO one = staffDepartmentRelatedApiService.getOneByClerkCodeAndDepartmentId(fromClerkCode,departmentId);
		if(one != null){
			//老店长清空好办这边code
			one.setClerkCode(null);
			one.setUpdateTime(new Date());
			staffDepartmentRelatedApiService.deleteCode(one);
		}
		logger.info("===========================》444444444444444");
		//新店长更新好办code
		StaffDepartmentRelatedDTO dto = new StaffDepartmentRelatedDTO();
		dto.setStaffDepartmentRelatedId(toStaffDepartmentRelatedId);
		dto.setClerkCode(fromClerkCode);
		dto.setUpdateTime(new Date());
		staffDepartmentRelatedApiService.updateById(dto);
		logger.info("===========================》555555555555555");
		if(StringUtils.isNotEmpty(oldStaffDepartmentRelatedDTO.getClerkCode())){
			//新店长老clerkCode对应的gicClerk更新gic姓名
			List<String> clerkCodes = new ArrayList<>();
			clerkCodes.add(oldStaffDepartmentRelatedDTO.getClerkCode());
			List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
			for(ClerkDTO clerkDTO :list){
				clerkDTO.setPhoneNumber("--");
				clerkDTO.setClerkName(clerkDTO.getClerkName()+"(已解绑)");
				clerkDTO.setHeadImgUrl("");
				clerkService.updateClerk(clerkDTO);
			}
		}
		logger.info("===========================》666666666666666");

		//老店长更新gic那边的数据为新店长数据
		List<String> clerkCodes = new ArrayList<>();
		clerkCodes.add(fromClerkCode);
		List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
		StaffDepartmentRelatedDTO staffDepartmentRelatedDTO = staffDepartmentRelatedApiService.getByStaffDepartmentRelatedId(toStaffDepartmentRelatedId);
		StaffDTO staffDTO = staffApiService.selectById(staffDepartmentRelatedDTO.getStaffId());
		logger.info("===========================》77777777777777");
		for(ClerkDTO clerkDTO :list){
			clerkDTO.setPhoneNumber(staffDTO.getPhoneNumber());
			clerkDTO.setClerkName(staffDTO.getStaffName());
			clerkDTO.setHeadImgUrl(StringUtils.isEmpty(staffDTO.getHeadImg())?"":staffDTO.getHeadImg());
			clerkService.updateClerk(clerkDTO);
		}
		logger.info("===========================》888888888888888");		
	}
	@Transactional
	@Override
	public void clerkUnbind(String departmentId, String fromClerkCode,
			String toStaffId, String manager) {
		StaffDepartmentRelatedDTO staffDepartmentRelatedDTO = staffDepartmentRelatedApiService.getOneByStaffIdAndDepartmentId(toStaffId, departmentId);
		String oldClerkCode = staffDepartmentRelatedDTO.getClerkCode();
		if("1".equals(manager)){
			//店长操作
			//第一个点击的人的clerkCode置空
			StaffDepartmentRelatedDTO one = staffDepartmentRelatedApiService.getOneByClerkCodeAndDepartmentId(fromClerkCode,departmentId);
			if(one != null){
				//存在，则先置空
				one.setClerkCode(null);
				one.setUpdateTime(new Date());
				staffDepartmentRelatedApiService.deleteCode(one);
			}
			StaffDepartmentRelatedDTO dto = staffDepartmentRelatedApiService.getOneByStaffIdAndDepartmentId(toStaffId, departmentId);
				//存在，则先置空
			dto.setClerkCode(fromClerkCode);
			dto.setUpdateTime(new Date());
			staffDepartmentRelatedApiService.updateById(dto);
			//更新gic数据
			DepartmentDTO departmentDTO = departmentApiService.selectById(departmentId);
			String storeId = departmentDTO.getRelatedId();
			List<String> clerkCodes = new ArrayList<>();
			clerkCodes.add(fromClerkCode);
			List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
			StaffDTO staffDTO = staffApiService.selectById(toStaffId);
			for(ClerkDTO clerkDTO :list){
				clerkDTO.setPhoneNumber(staffDTO.getPhoneNumber());
				clerkDTO.setClerkName(staffDTO.getStaffName());
				clerkDTO.setHeadImgUrl(StringUtils.isEmpty(staffDTO.getHeadImg())?"":staffDTO.getHeadImg());
				clerkService.updateClerk(clerkDTO);
			}
			//清空gic原来的手机号
			List<String> oldClerkCodes = new ArrayList<>();
			oldClerkCodes.add(oldClerkCode);
			List<ClerkDTO> oldList = clerkService.listClerk(storeId, oldClerkCodes, true);
			for(ClerkDTO clerkDTO :oldList){
				clerkDTO.setPhoneNumber("--");
				clerkDTO.setClerkName(clerkDTO.getClerkName()+"(已解绑)");
				clerkDTO.setHeadImgUrl("");
				clerkService.updateClerk(clerkDTO);
			}

		}else{
			//把别人的的clerkCode置空
			logger.info("000000000000");
			StaffDepartmentRelatedDTO one = staffDepartmentRelatedApiService.getOneByClerkCodeAndDepartmentId(fromClerkCode,departmentId);
			if(one != null){
				//存在，则先置空
				logger.info("111111111111111");
				one.setClerkCode(null);
				one.setUpdateTime(new Date());
				staffDepartmentRelatedApiService.deleteCode(one);
			}
			logger.info("222222222222222");
			//别人的clerkCOde换到自己上
			StaffDepartmentRelatedDTO dto = staffDepartmentRelatedApiService.getOneByStaffIdAndDepartmentId(toStaffId, departmentId);
			logger.info("3333333333333");
			dto.setClerkCode(fromClerkCode);
			dto.setUpdateTime(new Date());
			staffDepartmentRelatedApiService.updateById(dto);
			//更新gic数据
			DepartmentDTO departmentDTO = departmentApiService.selectById(departmentId);
			String storeId = departmentDTO.getRelatedId();
			List<String> clerkCodes = new ArrayList<>();
			clerkCodes.add(fromClerkCode);
			List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
			StaffDTO staffDTO = staffApiService.selectById(toStaffId);
			logger.info("444444444444");
			for(ClerkDTO clerkDTO :list){
				clerkDTO.setPhoneNumber(staffDTO.getPhoneNumber());
				clerkDTO.setClerkName(staffDTO.getStaffName());
				clerkDTO.setHeadImgUrl(StringUtils.isEmpty(staffDTO.getHeadImg())?"":staffDTO.getHeadImg());
				clerkService.updateClerk(clerkDTO);
			}
			
			//清空gic原来的手机号
			List<String> oldClerkCodes = new ArrayList<>();
			oldClerkCodes.add(oldClerkCode);
			logger.info("oldClerkCode====================>{}",oldClerkCode);
			List<ClerkDTO> oldList = clerkService.listClerk(storeId, oldClerkCodes, true);
			logger.info("oldList====================>{}",JSONObject.toJSONString(oldList));
			for(ClerkDTO clerkDTO :oldList){
				clerkDTO.setPhoneNumber("--");
				clerkDTO.setClerkName(clerkDTO.getClerkName()+"(已解绑)");
				clerkDTO.setHeadImgUrl("");
				clerkService.updateClerk(clerkDTO);
			}
		}		
	}
	@Transactional
	@Override
	public void clerkSingleUnbind(String fromClerkCode, String departmentId) {
		//将自己的clerkCode置空
		StaffDepartmentRelatedDTO one = staffDepartmentRelatedApiService.getOneByClerkCodeAndDepartmentId(fromClerkCode, departmentId);
		if(one != null){
			//存在，则先置空
			one.setClerkCode(null);
			one.setUpdateTime(new Date());
			staffDepartmentRelatedApiService.deleteCode(one);
		}
		//更新gic数据
		DepartmentDTO departmentDTO = departmentApiService.selectById(departmentId);
		String storeId = departmentDTO.getRelatedId();
		List<String> clerkCodes = new ArrayList<>();
		clerkCodes.add(fromClerkCode);
		List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
		for(ClerkDTO clerkDTO :list){
			clerkDTO.setPhoneNumber("--");
			clerkDTO.setClerkName(clerkDTO.getClerkName()+"(已解绑)");
			clerkDTO.setHeadImgUrl("");
			clerkService.updateClerk(clerkDTO);
		}		
	}
	@Transactional
	@Override
	public void staffBind(String departmentId, String fromClerkCode,
			String fromStaffDepartmentRelatedId) {
		StaffDepartmentRelatedDTO oldStaffDepartmentRelatedDTO = staffDepartmentRelatedApiService.getByStaffDepartmentRelatedId(fromStaffDepartmentRelatedId);
		if(oldStaffDepartmentRelatedDTO!=null){
			//删除gic测的手机号和姓名
			String clerkCode = oldStaffDepartmentRelatedDTO.getClerkCode();
			if(StringUtils.isNotBlank(clerkCode)){
				DepartmentDTO departmentDTO = departmentApiService.selectById(departmentId);
				String storeId = departmentDTO.getRelatedId();
				List<String> clerkCodes = new ArrayList<>();
				clerkCodes.add(clerkCode);
				List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
				for(ClerkDTO clerkDTO :list){
					clerkDTO.setPhoneNumber("--");
					clerkDTO.setClerkName(clerkDTO.getClerkName()+"(已解绑)");
					clerkDTO.setHeadImgUrl("");
					clerkService.updateClerk(clerkDTO);
				}
			}
		}
		//将指定人绑定clerkCode
		StaffDepartmentRelatedDTO dto = new StaffDepartmentRelatedDTO();
		dto.setStaffDepartmentRelatedId(fromStaffDepartmentRelatedId);
		dto.setClerkCode(fromClerkCode);
		dto.setUpdateTime(new Date());
		staffDepartmentRelatedApiService.updateById(dto);
		
		//更新gic数据
		DepartmentDTO departmentDTO = departmentApiService.selectById(departmentId);
		String storeId = departmentDTO.getRelatedId();
		List<String> clerkCodes = new ArrayList<>();
		clerkCodes.add(fromClerkCode);
		List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
		StaffDepartmentRelatedDTO staffDepartmentRelatedDTO = staffDepartmentRelatedApiService.getByStaffDepartmentRelatedId(fromStaffDepartmentRelatedId);
		StaffDTO staffDTO = staffApiService.selectById(staffDepartmentRelatedDTO.getStaffId());
		for(ClerkDTO clerkDTO :list){
			clerkDTO.setPhoneNumber(staffDTO.getPhoneNumber());
			clerkDTO.setClerkName(staffDTO.getStaffName());
			clerkDTO.setHeadImgUrl(StringUtils.isEmpty(staffDTO.getHeadImg())?"":staffDTO.getHeadImg());
			clerkService.updateClerk(clerkDTO);
		}		
	}


}
