package com.gic.haoban.manage.web.controller;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.enterprise.api.dto.PowerStoreGroupDTO;
import com.gic.enterprise.api.service.StoreGroupService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
public class GicDepartmentController extends WebBaseController{
	
	private static Logger logger  = LoggerFactory.getLogger(GicDepartmentController.class);
	
	@Autowired
	private StoreGroupService storeGroupService;
	
	@RequestMapping("gic-department-list")
	public HaobanResponse departmentList(String enterpriseId,BasePageInfo pageInfo,String keyWord) {
		List<PowerStoreGroupDTO>  departmentList = storeGroupService.getStoreGroupList(enterpriseId, keyWord);

		return resultResponse(HaoBanErrCode.ERR_1,departmentList);
		
	}

}
