package com.gic.haoban.manage.web.controller;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.gic.haoban.common.utils.CheckSmsCodeUtil;
import com.gic.haoban.common.utils.GooglePhoneNumberUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.communicate.api.service.valid.ValidationCodeService;
import com.gic.haoban.manage.api.dto.HelpDTO;
import com.gic.haoban.manage.api.service.HelpApiService;
import com.gic.haoban.manage.web.anno.IgnoreLogin;
//import com.gic.haoban.manage.api.dto.StaffDTO;
//import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.redis.data.util.RedisUtil;
import com.gic.reponse.SendSmsResponse;

@RestController
public class HelpController extends WebBaseController{
	
private static Logger logger = LoggerFactory.getLogger(HelpController.class);
	
	@Autowired
	private HelpApiService helpApiService;

    /**
     * 帮助中心列表
     * @return
     */
	@IgnoreLogin
    @RequestMapping("/get-help-list")
    public HaobanResponse getHelpList() {
    	
    	List<HelpDTO> list = helpApiService.getList();
    	return resultResponse(HaoBanErrCode.ERR_1,list);
    }

}
