package com.gic.haoban.manage.web.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.api.base.commons.Page;
import com.gic.clerk.api.service.ClerkService;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.dto.StoreSearchDTO;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.PageResult;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseRelatedApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
@RequestMapping("/store")
public class StoreController extends WebBaseController{
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private DepartmentApiService departmentApiService;
	@Autowired
	private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;
	@Autowired
	private WxEnterpriseRelatedApiService wxEnterpriseRelatedApiService;
	@Autowired
	private StoreService storeService;
	//门店列表
	@RequestMapping("/find-simple-page")
	public HaobanResponse storeList(String enterpriseId,BasePageInfo basePageInfo) {
        Page page = new Page<>();
        page.setCurrentPage(basePageInfo.getPageNum());
        page.setPageSize(basePageInfo.getPageSize());
        StoreSearchDTO storeSearchDTO = new StoreSearchDTO();
        storeSearchDTO.setEnterpriseId(enterpriseId);
        storeSearchDTO.setStatus("2");
        Page<StoreDTO> resultPage = storeService.storeListPage(page, storeSearchDTO);
        List<StoreDTO> resultList = resultPage.getResult();
		PageResult<StoreDTO> pageVo = new PageResult<>();
        pageVo.setList(resultList);
        pageVo.setPageNum(page.getCurrentPage());
        pageVo.setPages(resultPage.getPages());
        pageVo.setPageSize(page.getPageSize());
        pageVo.setTotal(resultPage.getTotalCount());
        return resultResponse(HaoBanErrCode.ERR_1,pageVo);
	}
	
	
	
}
