package com.gic.haoban.manage.web.controller;

import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.DictDTO;
import com.gic.haoban.manage.api.service.DictApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.vo.DictVo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Arrays;
import java.util.List;

/**
 * Created 2020/3/26.
 *
 * @author hua
 */
@Controller
public class DictController extends WebBaseController {

    @Autowired
    private DictApiService dictApiService;

    @RequestMapping("/dict-list")
    @ResponseBody
    public HaobanResponse queryDictList(String dictKeys) {
        if (StringUtils.isBlank(dictKeys)) {
            return resultResponse(HaoBanErrCode.ERR_5);
        }
        String[] split = dictKeys.split(",");
        List<DictDTO> ret = dictApiService.queryList(Arrays.asList(split));
        return resultResponse(HaoBanErrCode.ERR_1, EntityUtil.changeEntityListByOrika(DictVo.class, ret));
    }
}
