package com.gic.haoban.manage.web.controller;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import com.gic.commons.util.GlobalInfo;
import com.gic.commons.util.GlobalVar;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.thirdparty.api.dto.PicUploadResDTO;
import com.gic.thirdparty.api.service.QQCloudPicService;

@RestController
public class UploadController extends WebBaseController{
	
	 	@Autowired
	    private QQCloudPicService qqCloudPicService;


	    @RequestMapping("upload-img")
	    public HaobanResponse imgUpload(HttpServletRequest request) throws Exception {
	        MultipartHttpServletRequest multiRequest = (MultipartHttpServletRequest) request;
	        Iterator<String> iter = multiRequest.getFileNames();
	        java.util.List<Map<String, Object>> picList = new ArrayList<>();
	        while (iter.hasNext()) {
	            String fileName = iter.next();
	            List<MultipartFile> list = multiRequest.getMultiFileMap().get(fileName);
	            Map<String, Object> map = null;
	            for (int i = 0; i < list.size(); i++) {
	                map = new HashMap<>();
	                MultipartFile mf = list.get(i);
	                InputStream in = mf.getInputStream();
	                byte[] fileBuffer = null;
	                if (null != in) {
	                    int len = in.available();
	                    fileBuffer = new byte[len];
	                    in.read(fileBuffer);
	                }
	                PicUploadResDTO picUploadResDTO = qqCloudPicService.uploadPic(
	                        GlobalVar.ctxPropertiesMap.get(GlobalInfo.QQPIC_KEY_ENTERPRISE), fileBuffer);
	                if (picUploadResDTO != null) {
	                    picUploadResDTO.print();
	                    map.put("qcloudImageUrl", picUploadResDTO.downloadUrl);
	                    map.put("imageFiledCode", picUploadResDTO.fileId);
	                }
	                picList.add(map);
	            }
	        }
	        return resultResponse(HaoBanErrCode.ERR_1, picList);
	    }

}
